import { TypedEmitter } from 'tiny-typed-emitter';
const InterfaceType = 'uart';
export class UARTInterface extends TypedEmitter {
    constructor(configuration) {
        super();
        this.interfaceType = InterfaceType;
        this.configuration = configuration;
    }
    retransmit() {
        throw new Error('Method not implemented.');
    }
    // TODO: add real implementation
    downstreamData(data) {
        console.log(data);
    }
    sendFrame(frame) {
        this.emit('upstreamData', frame);
    }
}
export class ConstructableUARTInterface {
    constructor(signals) {
        this.interfaceType = InterfaceType;
        this.signals = signals;
    }
    getDescription() {
        return {
            availableSignals: { uart: this.signals },
        };
    }
    create(configuration) {
        return new UARTInterface(configuration);
    }
}
//# sourceMappingURL=connectionInterface.js.map